# coding: utf-8

"""
    Investment Analyst Coverage

    The Analyst Coverage API enables users to assign, transfer, or remove analyst coverage assignments for one or more entities. It also support discovery of coverage for an analyst or entity today or in the past.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_investment_research.agraph.investment_research.analyst.coverage.v1.AnalystCoverageAPI.models.types_entity_id import TypesEntityId
from asdk_plugin_investment_research.agraph.investment_research.analyst.coverage.v1.AnalystCoverageAPI.models.v1_coverage_action_type import V1CoverageActionType

class V1AnalystCoverage(BaseModel):
    """
    ResearchCoverage describes...
    """
    id: Optional[StrictStr] = Field(None, description="Resources must have a 'id' field. Id describes the computer or human assigned resource identifier.")
    entity_id: Optional[TypesEntityId] = Field(None, alias="entityId")
    analyst_id: Optional[StrictStr] = Field(None, alias="analystId")
    analyst_role: Optional[StrictStr] = Field(None, alias="analystRole")
    creator: Optional[StrictStr] = None
    start_time: Optional[datetime] = Field(None, alias="startTime")
    modifier: Optional[StrictStr] = None
    end_time: Optional[datetime] = Field(None, alias="endTime")
    action: Optional[V1CoverageActionType] = None
    __properties = ["id", "entityId", "analystId", "analystRole", "creator", "startTime", "modifier", "endTime", "action"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1AnalystCoverage:
        """Create an instance of V1AnalystCoverage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of entity_id
        if self.entity_id:
            _dict['entityId'] = self.entity_id.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1AnalystCoverage:
        """Create an instance of V1AnalystCoverage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1AnalystCoverage.parse_obj(obj)

        _obj = V1AnalystCoverage.parse_obj({
            "id": obj.get("id"),
            "entity_id": TypesEntityId.from_dict(obj.get("entityId")) if obj.get("entityId") is not None else None,
            "analyst_id": obj.get("analystId"),
            "analyst_role": obj.get("analystRole"),
            "creator": obj.get("creator"),
            "start_time": obj.get("startTime"),
            "modifier": obj.get("modifier"),
            "end_time": obj.get("endTime"),
            "action": obj.get("action")
        })
        return _obj

