# coding: utf-8

"""
    Investment Analyst Coverage

    The Analyst Coverage API enables users to assign, transfer, or remove analyst coverage assignments for one or more entities. It also support discovery of coverage for an analyst or entity today or in the past.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist

class V1SearchActiveAnalystCoverageRequest(BaseModel):
    """
    V1SearchActiveAnalystCoverageRequest
    """
    filter_criteria: Optional[conlist(StrictStr)] = Field(None, alias="filterCriteria")
    order_by: Optional[StrictStr] = Field(None, alias="orderBy")
    page_size: Optional[StrictInt] = Field(None, alias="pageSize", description="The maximum number of coverages to return. The service may return fewer than this value. Default 10 note will be returned.")
    page_number: Optional[StrictInt] = Field(None, alias="pageNumber")
    __properties = ["filterCriteria", "orderBy", "pageSize", "pageNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1SearchActiveAnalystCoverageRequest:
        """Create an instance of V1SearchActiveAnalystCoverageRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1SearchActiveAnalystCoverageRequest:
        """Create an instance of V1SearchActiveAnalystCoverageRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1SearchActiveAnalystCoverageRequest.parse_obj(obj)

        _obj = V1SearchActiveAnalystCoverageRequest.parse_obj({
            "filter_criteria": obj.get("filterCriteria"),
            "order_by": obj.get("orderBy"),
            "page_size": obj.get("pageSize"),
            "page_number": obj.get("pageNumber")
        })
        return _obj

