# coding: utf-8

"""
    Research Note

    Create, modify, delete and retrieve research notes.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from asdk_plugin_investment_research.agraph.investment_research.content.research_note.v2.ResearchNoteAPI.models.v2_research_note_query import V2ResearchNoteQuery

class V2FilterResearchNotesRequest(BaseModel):
    """
    The request message for ResearchAPI.FilterResearch.
    """
    query: Optional[V2ResearchNoteQuery] = None
    page_size: Optional[StrictInt] = Field(None, alias="pageSize", description="The maximum number of research notes to return. The service may return fewer than this value. If unspecified, at most 10 note will be returned.")
    page_token: Optional[StrictStr] = Field(None, alias="pageToken", description="A page token, received from a previous 'FilterResearchNotes' call. Provide this to retrieve the subsequent page.  When paginating, all other parameters provided to 'FilterResearchNotes' must match the call that provided the page token.")
    __properties = ["query", "pageSize", "pageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V2FilterResearchNotesRequest:
        """Create an instance of V2FilterResearchNotesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query
        if self.query:
            _dict['query'] = self.query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V2FilterResearchNotesRequest:
        """Create an instance of V2FilterResearchNotesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V2FilterResearchNotesRequest.parse_obj(obj)

        _obj = V2FilterResearchNotesRequest.parse_obj({
            "query": V2ResearchNoteQuery.from_dict(obj.get("query")) if obj.get("query") is not None else None,
            "page_size": obj.get("pageSize"),
            "page_token": obj.get("pageToken")
        })
        return _obj

