# coding: utf-8

"""
    Criterion

    Create, modify, delete, search and evaluate criteria.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_investment_research.agraph.investment_research.surveillance.criterion.v1.CriterionAPI.models.v1_criterion import V1Criterion

class V1SearchCriteriaResponse(BaseModel):
    """
    The response message for CriterionAPI.SearchCriteria.
    """
    criteria: Optional[conlist(V1Criterion)] = Field(None, description="The entities that match the specified CriterionRequest.")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as 'page_token' to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["criteria", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1SearchCriteriaResponse:
        """Create an instance of V1SearchCriteriaResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in criteria (list)
        _items = []
        if self.criteria:
            for _item in self.criteria:
                if _item:
                    _items.append(_item.to_dict())
            _dict['criteria'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1SearchCriteriaResponse:
        """Create an instance of V1SearchCriteriaResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1SearchCriteriaResponse.parse_obj(obj)

        _obj = V1SearchCriteriaResponse.parse_obj({
            "criteria": [V1Criterion.from_dict(_item) for _item in obj.get("criteria")] if obj.get("criteria") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

