# coding: utf-8

"""
    Investment Watchlist

    Create, modify, delete, and retrieve watchlists; Add and remove securities from watchlist.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist
from asdk_plugin_investment_research.agraph.investment_research.surveillance.watchlist.v1.WatchlistAPI.models.v1_watched_security import V1WatchedSecurity

class V1AddSecurityToWatchlistsRequest(BaseModel):
    """
    The request message for WatchlistAPI.AddSecurityToWatchlists.
    """
    securities: Optional[conlist(V1WatchedSecurity)] = None
    id: Optional[StrictStr] = None
    __properties = ["securities", "id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1AddSecurityToWatchlistsRequest:
        """Create an instance of V1AddSecurityToWatchlistsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in securities (list)
        _items = []
        if self.securities:
            for _item in self.securities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['securities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1AddSecurityToWatchlistsRequest:
        """Create an instance of V1AddSecurityToWatchlistsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1AddSecurityToWatchlistsRequest.parse_obj(obj)

        _obj = V1AddSecurityToWatchlistsRequest.parse_obj({
            "securities": [V1WatchedSecurity.from_dict(_item) for _item in obj.get("securities")] if obj.get("securities") is not None else None,
            "id": obj.get("id")
        })
        return _obj

